{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.SecurityHub.Types.MalwareState
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.SecurityHub.Types.MalwareState
  ( MalwareState
      ( ..,
        MalwareState_OBSERVED,
        MalwareState_REMOVAL_FAILED,
        MalwareState_REMOVED
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

newtype MalwareState = MalwareState'
  { fromMalwareState ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern MalwareState_OBSERVED :: MalwareState
pattern MalwareState_OBSERVED = MalwareState' "OBSERVED"

pattern MalwareState_REMOVAL_FAILED :: MalwareState
pattern MalwareState_REMOVAL_FAILED = MalwareState' "REMOVAL_FAILED"

pattern MalwareState_REMOVED :: MalwareState
pattern MalwareState_REMOVED = MalwareState' "REMOVED"

{-# COMPLETE
  MalwareState_OBSERVED,
  MalwareState_REMOVAL_FAILED,
  MalwareState_REMOVED,
  MalwareState'
  #-}
