{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.SecurityHub.Types.MalwareType
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.SecurityHub.Types.MalwareType
  ( MalwareType
      ( ..,
        MalwareType_ADWARE,
        MalwareType_BLENDED_THREAT,
        MalwareType_BOTNET_AGENT,
        MalwareType_COIN_MINER,
        MalwareType_EXPLOIT_KIT,
        MalwareType_KEYLOGGER,
        MalwareType_MACRO,
        MalwareType_POTENTIALLY_UNWANTED,
        MalwareType_RANSOMWARE,
        MalwareType_REMOTE_ACCESS,
        MalwareType_ROOTKIT,
        MalwareType_SPYWARE,
        MalwareType_TROJAN,
        MalwareType_VIRUS,
        MalwareType_WORM
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

newtype MalwareType = MalwareType'
  { fromMalwareType ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern MalwareType_ADWARE :: MalwareType
pattern MalwareType_ADWARE = MalwareType' "ADWARE"

pattern MalwareType_BLENDED_THREAT :: MalwareType
pattern MalwareType_BLENDED_THREAT = MalwareType' "BLENDED_THREAT"

pattern MalwareType_BOTNET_AGENT :: MalwareType
pattern MalwareType_BOTNET_AGENT = MalwareType' "BOTNET_AGENT"

pattern MalwareType_COIN_MINER :: MalwareType
pattern MalwareType_COIN_MINER = MalwareType' "COIN_MINER"

pattern MalwareType_EXPLOIT_KIT :: MalwareType
pattern MalwareType_EXPLOIT_KIT = MalwareType' "EXPLOIT_KIT"

pattern MalwareType_KEYLOGGER :: MalwareType
pattern MalwareType_KEYLOGGER = MalwareType' "KEYLOGGER"

pattern MalwareType_MACRO :: MalwareType
pattern MalwareType_MACRO = MalwareType' "MACRO"

pattern MalwareType_POTENTIALLY_UNWANTED :: MalwareType
pattern MalwareType_POTENTIALLY_UNWANTED = MalwareType' "POTENTIALLY_UNWANTED"

pattern MalwareType_RANSOMWARE :: MalwareType
pattern MalwareType_RANSOMWARE = MalwareType' "RANSOMWARE"

pattern MalwareType_REMOTE_ACCESS :: MalwareType
pattern MalwareType_REMOTE_ACCESS = MalwareType' "REMOTE_ACCESS"

pattern MalwareType_ROOTKIT :: MalwareType
pattern MalwareType_ROOTKIT = MalwareType' "ROOTKIT"

pattern MalwareType_SPYWARE :: MalwareType
pattern MalwareType_SPYWARE = MalwareType' "SPYWARE"

pattern MalwareType_TROJAN :: MalwareType
pattern MalwareType_TROJAN = MalwareType' "TROJAN"

pattern MalwareType_VIRUS :: MalwareType
pattern MalwareType_VIRUS = MalwareType' "VIRUS"

pattern MalwareType_WORM :: MalwareType
pattern MalwareType_WORM = MalwareType' "WORM"

{-# COMPLETE
  MalwareType_ADWARE,
  MalwareType_BLENDED_THREAT,
  MalwareType_BOTNET_AGENT,
  MalwareType_COIN_MINER,
  MalwareType_EXPLOIT_KIT,
  MalwareType_KEYLOGGER,
  MalwareType_MACRO,
  MalwareType_POTENTIALLY_UNWANTED,
  MalwareType_RANSOMWARE,
  MalwareType_REMOTE_ACCESS,
  MalwareType_ROOTKIT,
  MalwareType_SPYWARE,
  MalwareType_TROJAN,
  MalwareType_VIRUS,
  MalwareType_WORM,
  MalwareType'
  #-}
